--- asterisk/manager.c.old	2005-11-03 18:15:49.000000000 +0530
+++ asterisk/manager.c.new	2005-11-03 18:18:25.000000000 +0530
@@ -311,24 +311,37 @@
 {
 	int varlen, x;
 	struct ast_variable *head = NULL, *cur;
-	char *var, *val;
-	
-	varlen = strlen("Variable: ");	
+	char *var, *val, *next;
+
+	varlen = strlen("Variable: ");
 
 	for (x = 0; x < m->hdrcount; x++) {
 		if (!strncasecmp("Variable: ", m->headers[x], varlen)) {
-			var = val = ast_strdupa(m->headers[x] + varlen);
-			if (!var)
-				return head;				
-			strsep(&val, "=");
-			if (!val || ast_strlen_zero(var))
-				continue;
-			cur = ast_variable_new(var, val);
-			if (head) {
-				cur->next = head;
-				head = cur;
-			} else
-				head = cur;
+			next = ast_strdupa(m->headers[x] + varlen);
+			while(next) {
+				var = next;
+
+				if ((next = strchr(next, '|'))) {
+					*next = '\0';
+					next++;
+				}
+
+				if ((val = strchr(var, '='))) {
+					*val = '\0';
+					val++;
+
+					if (!val || ast_strlen_zero(var) || ast_strlen_zero(val))
+						continue;
+					cur = ast_variable_new(var, val);
+					if (head) {
+						cur->next = head;
+						head = cur;
+					} else
+						head = cur;
+				} else
+					ast_log(LOG_WARNING, "Ignoring entry '%s' with no =\n", var);
+
+			}
 		}
 	}
 
